# 1.  Projet Docker et jenkins

# 2. Installation de Docker:

les commandes d"installation:

$ sudo apt-get update

$ sudo apt-get install \apt-transport-https \ca-certificates \curl \software-properties-common

Et pour vérifier l'installation lance:

 $ docker run hello-world
 
 et si l'installation et bien réussi on aura ce message dans le terminal:
 
 
 ![run_docker](/uploads/06b5b438aaa82bdf947267d6be5d2f4f/run_docker.png)


# 3. Installation de jenkins dans Docker

 Tout d'abord, Docker doit etre installer correctement dans notre ordinateur, aprés on doit 
 
 ecxtraire l'image officielle des jenkins du référentiel Docker avec la commande suivante:


![pull_jenkin](/uploads/248ded744996291e52c34fc355907c20/pull_jenkin.png)


* Ensuite, on doit exécuter un conteneur en utilisant cette image et on doit mapper le répertoire de 
 
 données du conteneur sur l'hote. Le port Jenkins 8080 est également exposé à l'hôte sous le numéro
 
 8080.La commande suivante resume le travail:


![run_jenk](/uploads/bfc884a3323588aa634ccadef975777b/run_jenk.png)

# 4. Installation de plugin 

Aprés avoir installer jenkins dans docker on doit installer les plugins nécessaire pour notre travail:

![installation_plug](/uploads/ec306a469c18af65b3621d56f9053a95/installation_plug.png)

# 5. Integration d'un projet gitlab sur jenkins

Aprés avoir installer tout les utils nécessaire pour notre travail on a crier un projet sur la forge de l'université **gitlab** qu'on a appelé *---* ecrit on **JAVA** pour l'integrer par la suite sur jenkins. 

Ensuite nous allons crier un projet sur  **jenkins** qu'on a appelé **Tp1**, dans l'angler *gestion de code source* on doit choisir l'option  **git** pour pouvoir intégrir 

notre projet gitlab sur jenkins.

 Dans *Repository URL* on doit insérer le lien du projet GitLab . La branche du projet est automatiquement sélectionné *MASTER*

* L'image suivant illustre notre travail: 

![jen2](/uploads/5c738309955cb939b19d7c0f084cd927/jen2.png)

* Dans la rubrique **Build** il faut cliquer sur le lien **Exécuter un script shell**.

![BUILD](/uploads/fdb60b53005695cb8c2a1d79edae3b42/BUILD.png)

Cette option nous permet d'insérer les commandes nécessaire pour compiler et executer notre projet.

* Les commandes sont les suivantes:

> *Pour la compilation:*   javac Hello.java

> *Pour l'execution:*  java Hello

# 6. Test et Resultat

Nous allons maintenant tester le fonctionnement de notre projet, pour le faire il faut cliquer sur le lien **Lancer un build.**

Cette action lance le script que nous avons précédemment inséré.

* Pour avoir le résultat de notre execution on doit cliquer sur **Console Output**.

![console](/uploads/00ec781fd8bcfec4b03892861383cc53/console.png)

* Resultat

 


![result](/uploads/56caa8436762a363e56a8f00d361eaed/result.png)



